

module RedPack

  module Responder
    def ok(ctx, result)
    end

    def fail(ctx, err)
    end

  end



  class NullResponder
    include RedPack::Responder

    def ok(ctx, result)
    end

    def fail(ctx, err)
      raise err
    end
  end


  class SyncRedisResponder
    include RedPack::Responder

    def initialize(redis, transcoder)
      @redis = redis
      @transcoder = transcoder
    end

    def send(response_queue_name, msg_id, err, retval)
      v = {:data => [RedPack::Consts::RESPONSE, msg_id, err, retval]}
      @redis.rpush(response_queue_name, @transcoder.pack(v))                   
    end

    def ok(ctx, result)
      if ctx.REQUEST? then
        self.send(ctx.response_queue_name, ctx.msg_id, nil, result)
      end
    end

    def fail(ctx, err)
      if ctx.REQUEST? then
        self.send(ctx.response_queue_name, ctx.msg_id, err, nil)        
      end
    end

  end



end
